#include <WinApi.au3>
#include <WindowsConstants.au3>
#include '_D2D_VSync.au3'
#include <WinAPIMisc.au3>

Opt('GUIOnEventMode', 1)

Global Const $sTitle = 'Test'
Global Const $iW = 512
Global Const $iH = 512
Global $hGUI, $hGFX, $hBMP, $hBUF, $hBRU
Global $bExit = False, $iCnt = 0
Global $iFPS = 0, $iFrameTimer = TimerInit()

_VSync_Startup() ; Kann irgendwo am Anfang stehen. Aber nicht in einem Loop, bitte nur 1x aufrufen !

$hGUI = GUICreate($sTitle, $iW, $iH)
$hDC = _WinAPI_GetDC($hGUI)
$vBUF = __CreateBitmap32($iW, $iH)
$hBRU = _WinAPI_CreateSolidBrush(0x888888)
$tRect = _WinAPI_CreateRect(0, 0, 100, 100)

GUISetOnEvent(-3, 'EVENT', $hGUI)
GUISetState(@SW_SHOW, $hGUI)

While Not $bExit
	$iCnt += 0.05
	_WinAPI_BitBlt(DllStructGetData($vBUF, 1), 0, 0, $iW, $iH, 0, 0, 0, $WHITENESS)
	DllStructSetData($tRect, 1, $iW/2 + Cos($iCnt) * 100 - 90)
	DllStructSetData($tRect, 2, $iW/2 + Sin($iCnt) * 100 - 90)
	DllStructSetData($tRect, 3, $iW/2 + Cos($iCnt) * 100 + 90)
	DllStructSetData($tRect, 4, $iW/2 + Sin($iCnt) * 100 + 90)
	_WinAPI_FillRect(DllStructGetData($vBUF, 1), $tRect, $hBRU)
	$iFPS += 1

	_VSync_Wait() ; Wartet bis das Bild aktualisiert wurde.
	_WinAPI_BitBlt($hDC, 0, 0, $iW, $iH, DllStructGetData($vBUF, 1), 0, 0, $SRCCOPY)

	If TimerDiff($iFrameTimer) >= 1000 Then
		$iFrameTimer = TimerInit()
		WinSetTitle($hGUI, '', $sTitle & ' @' & $iFPS)
		$iFPS = 0
	EndIf
WEnd

__DeleteBitmap32($vBUF)
_WinAPI_DeleteObject($hBRU)
_WinAPI_ReleaseDC($hGUI, $hDC)
_VSync_Shutdown() ; Irgendwo ans Ende. Ob man GDI+ vor- oder nachher abschaltet ist egal.

Func EVENT()
	Switch @GUI_CtrlId
		Case -3
			$bExit = True
	EndSwitch
EndFunc

Func __CreateBitmap32($iW, $iH)
	Local $hDC = DllCall('GDI32.DLL', 'handle', 'CreateCompatibleDC', 'handle', 0)[0], $tBMI = DllStructCreate('struct' & _
	';dword Size;long Width;long Height;word Planes;word BitCount;dword Compression;dword SizeImage;long XPelsPerMeter;long ' & _
	'YPelsPerMeter;dword ClrUsed;dword ClrImportant;endstruct;dword RGBQuad'), $t = DllStructSetData($tBMI, 'Size', _
	DllStructGetSize($tBMI) - 4) + DllStructSetData($tBMI, 'Width', $iW) + DllStructSetData($tBMI, 'Height', - $iH) _
	+ DllStructSetData($tBMI, 'Planes', 1) + DllStructSetData($tBMI, 'BitCount', 32), $aDIB = DllCall('GDI32.DLL', 'ptr', _
	'CreateDIBSection', 'hwnd', 0, 'ptr', DllStructGetPtr($tBMI), 'uint', 0, 'ptr*', 0, 'ptr', 0, 'uint', 0), $t = _
	DllCall('GDI32.DLL', 'handle', 'SelectObject', 'handle', $hDC, 'handle', $aDIB[0]), $vStr = DllStructCreate('int[5]') _
	, $t = DllStructSetData($vStr, 1, $hDC, 1) + DllStructSetData($vStr, 1, $iW, 2) + DllStructSetData($vStr, 1, $iH, 3) + _
	DllStructSetData($vStr, 1, $aDIB[4], 4) + DllStructSetData($vStr, 1, $aDIB[0], 5)
	Return $vStr
EndFunc

Func __DeleteBitmap32(ByRef $vStruct)
	DllCall('GDI32.DLL', 'bool', 'DeleteObject', 'handle', DllStructGetData($vStruct, 1, 5))
	DllCall('GDI32.DLL', 'bool', 'DeleteDC', 'handle', DllStructGetData($vStruct, 1, 1))
	$vStruct = 0
EndFunc