#include <GDIPlus.au3>
#include '_D2D_VSync.au3'

Opt('GUIOnEventMode', 1)

Global Const $sTitle = 'Test'
Global Const $iW = 512
Global Const $iH = 512
Global $hGUI, $hGFX, $hBMP, $hBUF, $hBRU
Global $bExit = False, $iCnt = 0
Global $iFPS = 0, $iFrameTimer = TimerInit()

_VSync_Startup() ; Kann irgendwo am Anfang stehen. Aber nicht in einem Loop, bitte nur 1x aufrufen !

_GDIPlus_Startup()
$hGUI = GUICreate($sTitle, $iW, $iH)
$hGFX = _GDIPlus_GraphicsCreateFromHWND($hGUI)
$hBMP = _GDIPlus_BitmapCreateFromGraphics($iW, $iH, $hGFX)
$hBUF = _GDIPlus_ImageGetGraphicsContext($hBMP)
$hBRU = _GDIPlus_BrushCreateSolid(0xFF888888)
_GDIPlus_GraphicsSetSmoothingMode($hBUF, 2)


GUISetOnEvent(-3, 'EVENT', $hGUI)
GUISetState(@SW_SHOW, $hGUI)

While Not $bExit
	$iCnt += 0.05
	_GDIPlus_GraphicsClear($hBUF, 0xFFFFFFFF)
	_GDIPlus_GraphicsFillEllipse($hBUF, $iW/2 + Cos($iCnt) * 100 - 90, $iH /2 + Sin($iCnt) * 100 - 90, 170, 170, $hBRU)
	$iFPS += 1

	_VSync_Wait() ; Wartet bis das Bild aktualisiert wurde.
	; Nach dem VSync hat man bei 60FPS ca. 16ms Zeit das Bild zu zeichnen.
	; Reicht diese Zeit nicht aus (was bei GDI+ und greren Fenstermaen der Fall ist),
	; so ist es sinnlos auf den VSync zu warten.

	_GDIPlus_GraphicsDrawImage($hGFX, $hBMP, 0, 0)
	; Man zeichnet NACHDEM man auf den VSync gewartet hat. Das klingt auf den ersten Blick
	; seltsam, da man so quasi immer 1 Frame hinterherhinkt. Der Grund ist: Die Zeichenoperation
	; die das Bild ins Fenster bringt braucht Zeit, damit kein Tearing auftritt darf beim
	; Zeichenvorgang der Bildschirm nicht aktualisiert werden. Zeichnet man VOR dem Warten,
	; so kann es passieren, dass man den Zeitpunkt nicht genau trifft und es tritt trotzdem Tearing auf.
	; Zeichnet man NACH dem Warten und ist die Zeichenfunktion in weniger als 16ms abgeschlossen
	; (GDI+ ist fr groe Fenster zu langsam), so kann kein Tearing auftreten.

	If TimerDiff($iFrameTimer) >= 1000 Then
		$iFrameTimer = TimerInit()
		WinSetTitle($hGUI, '', $sTitle & ' @' & $iFPS)
		$iFPS = 0
	EndIf
WEnd

_GDIPlus_BrushDispose($hBRU)
_GDIPlus_GraphicsDispose($hBUF)
_GDIPlus_BitmapDispose($hBMP)
_GDIPlus_GraphicsDispose($hGFX)
_GDIPlus_Shutdown()
_VSync_Shutdown() ; Irgendwo ans Ende. Ob man GDI+ vor- oder nachher abschaltet ist egal.

Func EVENT()
	Switch @GUI_CtrlId
		Case -3
			$bExit = True
	EndSwitch
EndFunc